Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## controlP5
Class Textfield

    java.lang.Object
      controlP5.Controller
          controlP5.Textfield

All Implemented Interfaces:
  CDrawable, ControllerInterface, ControlP5Constants

    public class Textfield

extends Controller

A singleline input textfield, use arrow keys to go back and forth, use backspace to delete characters. Using the up and down arrows lets you cycle through the history of the textfield. This is the best you can get. Font handling, font switching, measuring, left align, right align, etc. was giving me a big headache. not perfect, i think this is a good compromise.

+Example
  `

      /**
      * ControlP5 Textfield
      *
      *
      * find a list of public methods available for the Textfield Controller
      * at the bottom of this sketch.
      *
      * by Andreas Schlegel, 2012
      * www.sojamo.de/libraries/controlp5
      *
      */

      import controlP5.*;

      ControlP5 cp5;

      String textValue = "";

      void setup() {
        size(700,400);

        PFont font = createFont("arial",20);

        cp5 = new ControlP5(this);

        cp5.addTextfield("input")
           .setPosition(20,100)
           .setSize(200,40)
           .setFont(font)
           .setFocus(true)
           .setColor(color(255,0,0))
           ;

        cp5.addTextfield("textValue")
           .setPosition(20,170)
           .setSize(200,40)
           .setFont(createFont("arial",20))
           .setAutoClear(false)
           ;

        cp5.addBang("clear")
           .setPosition(240,170)
           .setSize(80,40)
           .getCaptionLabel().align(ControlP5.CENTER, ControlP5.CENTER)
           ;

        cp5.addTextfield("default")
           .setPosition(20,350)
           .setAutoClear(false)
           ;

        textFont(font);
      }

      void draw() {
        background(0);
        fill(255);
        text(cp5.get(Textfield.class,"input").getText(), 360,130);
        text(textValue, 360,180);
      }

      public void clear() {
        cp5.get(Textfield.class,"textValue").clear();
      }

      void controlEvent(ControlEvent theEvent) {
        if(theEvent.isAssignableFrom(Textfield.class)) {
          println("controlEvent: accessing a string from controller '"
                  +theEvent.getName()+"': "
                  +theEvent.getStringValue()
                  );
        }
      }

      public void input(String theText) {
        // automatically receives results from controller input
        println("a textfield event for controller 'input' : "+theText);
      }

      /*
      a list of all methods available for the Textfield Controller
      use ControlP5.printPublicMethodsFor(Textfield.class);
      to print the following list into the console.

      You can find further details about class Textfield in the javadoc.

      Format:
      ClassName : returnType methodName(parameter type)

      controlP5.Textfield : String getText()
      controlP5.Textfield : Textfield clear()
      controlP5.Textfield : Textfield keepFocus(boolean)
      controlP5.Textfield : Textfield setAutoClear(boolean)
      controlP5.Textfield : Textfield setFocus(boolean)
      controlP5.Textfield : Textfield setFont(ControlFont)
      controlP5.Textfield : Textfield setFont(PFont)
      controlP5.Textfield : Textfield setFont(int)
      controlP5.Textfield : Textfield setText(String)
      controlP5.Textfield : Textfield setValue(String)
      controlP5.Textfield : Textfield setValue(float)
      controlP5.Textfield : boolean isAutoClear()
      controlP5.Textfield : int getIndex()
      controlP5.Textfield : void draw(PApplet)
      controlP5.Textfield : void keyEvent(KeyEvent)
      controlP5.Textfield : void setInputFilter(int)
      controlP5.Textfield : void setPasswordMode(boolean)
      controlP5.Controller : CColor getColor()
      controlP5.Controller : ControlBehavior getBehavior()
      controlP5.Controller : ControlWindow getControlWindow()
      controlP5.Controller : ControlWindow getWindow()
      controlP5.Controller : ControllerProperty getProperty(String)
      controlP5.Controller : ControllerProperty getProperty(String, String)
      controlP5.Controller : Label getCaptionLabel()
      controlP5.Controller : Label getValueLabel()
      controlP5.Controller : List getControllerPlugList()
      controlP5.Controller : PImage setImage(PImage)
      controlP5.Controller : PImage setImage(PImage, int)
      controlP5.Controller : PVector getAbsolutePosition()
      controlP5.Controller : PVector getPosition()
      controlP5.Controller : String getAddress()
      controlP5.Controller : String getInfo()
      controlP5.Controller : String getName()
      controlP5.Controller : String getStringValue()
      controlP5.Controller : String toString()
      controlP5.Controller : Tab getTab()
      controlP5.Controller : Textfield addCallback(CallbackListener)
      controlP5.Controller : Textfield addListener(ControlListener)
      controlP5.Controller : Textfield bringToFront()
      controlP5.Controller : Textfield bringToFront(ControllerInterface)
      controlP5.Controller : Textfield hide()
      controlP5.Controller : Textfield linebreak()
      controlP5.Controller : Textfield listen(boolean)
      controlP5.Controller : Textfield lock()
      controlP5.Controller : Textfield plugTo(Object)
      controlP5.Controller : Textfield plugTo(Object, String)
      controlP5.Controller : Textfield plugTo(Object[])
      controlP5.Controller : Textfield plugTo(Object[], String)
      controlP5.Controller : Textfield registerProperty(String)
      controlP5.Controller : Textfield registerProperty(String, String)
      controlP5.Controller : Textfield registerTooltip(String)
      controlP5.Controller : Textfield removeBehavior()
      controlP5.Controller : Textfield removeCallback()
      controlP5.Controller : Textfield removeCallback(CallbackListener)
      controlP5.Controller : Textfield removeListener(ControlListener)
      controlP5.Controller : Textfield removeProperty(String)
      controlP5.Controller : Textfield removeProperty(String, String)
      controlP5.Controller : Textfield setArrayValue(float[])
      controlP5.Controller : Textfield setArrayValue(int, float)
      controlP5.Controller : Textfield setBehavior(ControlBehavior)
      controlP5.Controller : Textfield setBroadcast(boolean)
      controlP5.Controller : Textfield setCaptionLabel(String)
      controlP5.Controller : Textfield setColor(CColor)
      controlP5.Controller : Textfield setColorActive(int)
      controlP5.Controller : Textfield setColorBackground(int)
      controlP5.Controller : Textfield setColorCaptionLabel(int)
      controlP5.Controller : Textfield setColorForeground(int)
      controlP5.Controller : Textfield setColorValueLabel(int)
      controlP5.Controller : Textfield setDecimalPrecision(int)
      controlP5.Controller : Textfield setDefaultValue(float)
      controlP5.Controller : Textfield setHeight(int)
      controlP5.Controller : Textfield setId(int)
      controlP5.Controller : Textfield setImages(PImage, PImage, PImage)
      controlP5.Controller : Textfield setImages(PImage, PImage, PImage, PImage)
      controlP5.Controller : Textfield setLabelVisible(boolean)
      controlP5.Controller : Textfield setLock(boolean)
      controlP5.Controller : Textfield setMax(float)
      controlP5.Controller : Textfield setMin(float)
      controlP5.Controller : Textfield setMouseOver(boolean)
      controlP5.Controller : Textfield setMoveable(boolean)
      controlP5.Controller : Textfield setPosition(PVector)
      controlP5.Controller : Textfield setPosition(float, float)
      controlP5.Controller : Textfield setSize(PImage)
      controlP5.Controller : Textfield setSize(int, int)
      controlP5.Controller : Textfield setStringValue(String)
      controlP5.Controller : Textfield setUpdate(boolean)
      controlP5.Controller : Textfield setValueLabel(String)
      controlP5.Controller : Textfield setView(ControllerView)
      controlP5.Controller : Textfield setVisible(boolean)
      controlP5.Controller : Textfield setWidth(int)
      controlP5.Controller : Textfield show()
      controlP5.Controller : Textfield unlock()
      controlP5.Controller : Textfield unplugFrom(Object)
      controlP5.Controller : Textfield unplugFrom(Object[])
      controlP5.Controller : Textfield unregisterTooltip()
      controlP5.Controller : Textfield update()
      controlP5.Controller : Textfield updateSize()
      controlP5.Controller : boolean isActive()
      controlP5.Controller : boolean isBroadcast()
      controlP5.Controller : boolean isInside()
      controlP5.Controller : boolean isLabelVisible()
      controlP5.Controller : boolean isListening()
      controlP5.Controller : boolean isLock()
      controlP5.Controller : boolean isMouseOver()
      controlP5.Controller : boolean isMousePressed()
      controlP5.Controller : boolean isMoveable()
      controlP5.Controller : boolean isUpdate()
      controlP5.Controller : boolean isVisible()
      controlP5.Controller : float getArrayValue(int)
      controlP5.Controller : float getDefaultValue()
      controlP5.Controller : float getMax()
      controlP5.Controller : float getMin()
      controlP5.Controller : float getValue()
      controlP5.Controller : float[] getArrayValue()
      controlP5.Controller : int getDecimalPrecision()
      controlP5.Controller : int getHeight()
      controlP5.Controller : int getId()
      controlP5.Controller : int getWidth()
      controlP5.Controller : int listenerSize()
      controlP5.Controller : void remove()
      controlP5.Controller : void setView(ControllerView, int)
      java.lang.Object : String toString()
      java.lang.Object : boolean equals(Object)

      */

  `

Nested Class Summary
`static class` | `Textfield.InputFilter`

Field Summary
`static int` | `cursorWidth`

Fields inherited from class controlP5.Controller
`autoHeight, autoSpacing, autoWidth`

Fields inherited from interface controlP5.ControlP5Constants
`acceptClassList, ACTION_BROADCAST, ACTION_ENTER, ACTION_LEAVE, ACTION_PRESSED, ACTION_RELEASED, ACTION_RELEASEDOUTSIDE, ACTIVE, ALL, ALT, ARC, ARRAY, BACKSPACE, BASELINE, BITFONT, BOOLEAN, BOTTOM, BOTTOM_OUTSIDE, CAPTIONLABEL, CENTER, COMMANDKEY, CONTROL, controlEventClass, CUSTOM, DECREASE, DEFAULT, DELETE, DONE, DOWN, ELLIPSE, ENTER, ESCAPE, EVENT, eventMethod, FADEIN, FADEOUT, FIELD, FLOAT, HALF_PI, HIDE, HIGHLIGHT, HORIZONTAL, IDLE, IMAGE, INACTIVE, INCREASE, INTEGER, INVALID, KEYCONTROL, LEFT, LEFT_OUTSIDE, LINE, LOAD, MENU, METHOD, MOVE, MULTI, MULTIPLES, OVER, PI, PRESSED, PRINT, RELEASE, RESET, RIGHT, RIGHT_OUTSIDE, SAVE, SHIFT, SINGLE, SINGLE_COLUMN, SINGLE_ROW, SPRITE, STRING, SWITCH, SWITCH_BACK, SWITCH_FORE, TAB, TOP, TOP_OUTSIDE, TRANSITION_WAIT_FADEIN, TWO_PI, UP, VALUELABEL, VERBOSE, VERTICAL, WAIT`

Constructor Summary
`Textfield(ControlP5 theControlP5, ControllerGroup theParent, java.lang.String theName, java.lang.String theDefaultValue, int theX, int theY, int theWidth, int theHeight)`
`Textfield(ControlP5 theControlP5, java.lang.String theName)` Convenience constructor to extend Textfield.

Method Summary
`Textfield` | `clear()`
`void` | `draw(processing.core.PApplet theApplet)` the default draw function for each controller extending superclass Controller.
`int` | `getIndex()`
`java.lang.String` | `getText()`
`java.lang.String[]` | `getTextList()`
`boolean` | `isAutoClear()`
`boolean` | `isFocus()` check if the textfield is active and in focus.
`Textfield` | `keepFocus(boolean theValue)`
`void` | `keyEvent(java.awt.event.KeyEvent theKeyEvent)`
`Textfield` | `setAutoClear(boolean theValue)`
`Textfield` | `setColor(int theColor)`
`Textfield` | `setColorCursor(int theColor)`
`Textfield` | `setFocus(boolean theValue)`
`Textfield` | `setFont(ControlFont theFont)`
`Textfield` | `setFont(int theFont)`
`Textfield` | `setFont(processing.core.PFont thePFont)`
`Textfield` | `setHeight(int theHeight)`
`Textfield` | `setInputFilter(int theInputType)`
`Textfield` | `setPasswordMode(boolean theFlag)` TODO set the mode of the textfield to password mode, each character is shown as a "*" like e.g.
`Textfield` | `setText(java.lang.String theText)`
`Textfield` | `setValue(float theValue)`
`Textfield` | `setValue(java.lang.String theText)`
`Textfield` | `setWidth(int theWidth)`
`Textfield` | `submit()` make the controller execute a return event.

Methods inherited from class controlP5.Controller
`add, addCallback, addListener, align, bringToFront, bringToFront, changeValue, getAbsolutePosition, getAddress, getArrayValue, getArrayValue, getBehavior, getCaptionLabel, getColor, getControllerPlugList, getControlWindow, getDecimalPrecision, getDefaultValue, getHeight, getId, getLabel, getMax, getMin, getName, getParent, getPickingColor, getPointer, getPosition, getProperty, getProperty, getStringValue, getTab, getValue, getValueLabel, getWidth, getWindow, hide, init, isActive, isBroadcast, isInside, isLabelVisible, isListening, isLock, isMouseOver, isMousePressed, isMoveable, isUpdate, isVisible, linebreak, listen, listenerSize, lock, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, plugTo, plugTo, plugTo, plugTo, registerProperty, registerProperty, registerTooltip, remove, remove, removeBehavior, removeCallback, removeCallback, removeListener, removeProperty, removeProperty, setAbsolutePosition, setAddress, setArrayValue, setArrayValue, setBehavior, setBroadcast, setCaptionLabel, setColor, setColorActive, setColorBackground, setColorCaptionLabel, setColorForeground, setColorValueLabel, setDecimalPrecision, setDefaultValue, setGroup, setGroup, setId, setImage, setImage, setImages, setImages, setImages, setLabelVisible, setLock, setMax, setMin, setMouseOver, setMousePressed, setMoveable, setParent, setPosition, setPosition, setSize, setSize, setStringValue, setTab, setTab, setUpdate, setValueLabel, setView, setView, setVisible, show, unlock, unplugFrom, unplugFrom, unregisterTooltip, update, updateAbsolutePosition, updateEvents, updateInternalEvents, updateSize`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface controlP5.ControllerInterface
`continuousUpdateEvents, parent, setColorLabel, setColorValue, setLabel`

Field Detail

### cursorWidth

    public static int cursorWidth

Constructor Detail

### Textfield

    public Textfield(ControlP5 theControlP5,
                     ControllerGroup theParent,
                     java.lang.String theName,
                     java.lang.String theDefaultValue,
                     int theX,
                     int theY,
                     int theWidth,
                     int theHeight)

### Textfield

    public Textfield(ControlP5 theControlP5,
                     java.lang.String theName)

  Convenience constructor to extend Textfield.

  Parameters:
    `theControlP5` -
    `theName` -
    +Example
      `

          /**
           * ControlP5 extending Controllers
           *
           * the following example shows how to extend the Controller class to
           * create customizable Controllers. You can either extend the Controller class itself,
           * or any class that extends Controller itself like the Slider, Button, DropdownList, etc.
           *
           * How to:
           *
           * 1) do a super call to the convenience constructor requiring
           * 2 parameter (ControlP5 instance, name)
           *
           * 2) the Controller class has a set of empty methods that allow you to capture
           * inputs from the mouse including
           * onEnter(), onLeave(), onPress(), onRelease(), onClick(), onScroll(int), onDrag()
           * These you can override and include functionality as needed.
           *
           * 3) use method getPointer() to return the local (relative)
           * xy-coordinates of the controller
           *
           * 4) after instantiation custom controllers are treated the same
           * as default controlP5 controllers.
           *
           * by Andreas Schlegel, 2012
           * www.sojamo.de/libraries/controlp5
           *
           */

          import controlP5.*;

          ControlP5 cp5;
          PApplet p;

          void setup() {
            size(400, 400);
            cp5 = new ControlP5(this);

            // create 2 groups to show nesting of custom controllers and
            //
            Group g1 = cp5.addGroup("a").setPosition(0,100).setWidth(180);
            Group g2 = cp5.addGroup("b").setPosition(0,10).setWidth(180);
            g2.moveTo(g1);

            // create 2 custom Controllers from class MyButton
            // MyButton extends Controller and inherits all methods accordingly.
            new MyButton(cp5, "b1").setPosition(0, 0).setSize(180, 200).moveTo(g2);
            new MyButton(cp5, "b2").setPosition(205, 15).setSize(180, 200);

          }

          void draw() {
            background(0);
          }

          // b1 will be called from Controller b1
          public void b1(float theValue) {
            println("yay button "+theValue);
          }

          public void controlEvent(ControlEvent theEvent) {
            println("controlEvent : "+theEvent);
          }

          // Create a custom Controller, please not that
          // MyButton extends Controller,
          // is an indicator for the super class about the type of
          // custom controller to be created.

          class MyButton extends Controller {

            int current = 0xffff0000;

            float a = 128;

            float na;

            int y;

            // use the convenience constructor of super class Controller
            // MyButton will automatically registered and move to the
            // default controlP5 tab.

            MyButton(ControlP5 cp5, String theName) {
              super(cp5, theName);

              // replace the default view with a custom view.
              setView(new ControllerView() {
                public void display(PApplet p, Object b) {
                  // draw button background
                  na += (a-na) * 0.1;
                  p.fill(current,na);
                  p.rect(0, 0, getWidth(), getHeight());

                  // draw horizontal line which can be moved on the x-axis
                  // using the scroll wheel.
                  p.fill(0,255,0);
                  p.rect(0,y,width,10);

                  // draw the custom label
                  p.fill(128);
                  translate(0,getHeight()+14);
                  p.text(getName(),0,0);
                  p.text(getName(),0,0);

                }
              }
              );
            }

            // override various input methods for mouse input control
            void onEnter() {
              cursor(HAND);
              println("enter");
              a = 255;
            }

            void onScroll(int n) {
              println("scrolling");
              y -= n;
              y = constrain(y,0,getHeight()-10);
            }

            void onPress() {
              println("press");
              current = 0xffffff00;
            }

            void onClick() {
              Pointer p1 = getPointer();
              println("clicked at "+p1.x()+", "+p1.y());
              current = 0xffffff00;
              setValue(y);
            }

            void onRelease() {
              println("release");
              current = 0xffffffff;
            }

            void onMove() {
              println("moving "+this+" "+_myControlWindow.getMouseOverList());
            }

            void onDrag() {
              current = 0xff0000ff;
              Pointer p1 = getPointer();
              float dif = dist(p1.px(),p1.py(),p1.x(),p1.y());
              println("dragging at "+p1.x()+", "+p1.y()+" "+dif);
            }

            void onReleaseOutside() {
              onLeave();
            }

            void onLeave() {
              println("leave");
              cursor(ARROW);
              a = 128;
            }
          }

      `

Method Detail

### clear

    public Textfield clear()

### draw

    public void draw(processing.core.PApplet theApplet)

  Description copied from class: `Controller`
  the default draw function for each controller extending superclass Controller. This draw function will take care of default matrix operations and will call the display function of the current ControllerView object active for this particular controller.

  Specified by:
    `draw` in interface `CDrawable`
  Specified by:
    `draw` in interface `ControllerInterface`
  Overrides:
    `draw` in class `Controller`
  Parameters:
    `theApplet` - PApplet
  See Also:
    `ControllerView`

### getIndex

    public int getIndex()

### getText

    public java.lang.String getText()

### getTextList

    public java.lang.String[] getTextList()

### isAutoClear

    public boolean isAutoClear()

### isFocus

    public boolean isFocus()

  check if the textfield is active and in focus.

  Returns:
    boolean

### keepFocus

    public Textfield keepFocus(boolean theValue)

### keyEvent

    public void keyEvent(java.awt.event.KeyEvent theKeyEvent)

  Specified by:
    `keyEvent` in interface `ControllerInterface`
  Overrides:
    `keyEvent` in class `Controller`

### setAutoClear

    public Textfield setAutoClear(boolean theValue)

### setColor

    public Textfield setColor(int theColor)

### setColorCursor

    public Textfield setColorCursor(int theColor)

### setFocus

    public Textfield setFocus(boolean theValue)

### setFont

    public Textfield setFont(ControlFont theFont)

### setFont

    public Textfield setFont(int theFont)

### setFont

    public Textfield setFont(processing.core.PFont thePFont)

### setHeight

    public Textfield setHeight(int theHeight)

  Overrides:
    `setHeight` in class `Controller`
  Returns:
    Controller

### setInputFilter

    public Textfield setInputFilter(int theInputType)

### setPasswordMode

    public Textfield setPasswordMode(boolean theFlag)

  TODO set the mode of the textfield to password mode, each character is shown as a "*" like e.g. in online password forms.

  Parameters:
    `theFlag` - boolean

### setText

    public Textfield setText(java.lang.String theText)

### setValue

    public Textfield setValue(float theValue)

  Specified by:
    `setValue` in interface `ControllerInterface`
  Overrides:
    `setValue` in class `Controller`
  Parameters:
    `theValue` - float

### setValue

    public Textfield setValue(java.lang.String theText)

### setWidth

    public Textfield setWidth(int theWidth)

  Overrides:
    `setWidth` in class `Controller`
  Returns:
    Controller

### submit

    public Textfield submit()

  make the controller execute a return event. submit the current content of the texfield.

Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

processing library controlP5 by Andreas Schlegel. (c) 2006-2012